<?php
if (!defined('__TYPECHO_ROOT_DIR__')) exit;

function themeConfig($form) {
    $faviconpicUrl = new Typecho_Widget_Helper_Form_Element_Text('faviconpicUrl', NULL, NULL, _t('站点favicon'), _t('在这里填入一个图片URL地址, 用于显示favicon'));
    $form->addInput($faviconpicUrl);

    $indexpicUrl = new Typecho_Widget_Helper_Form_Element_Text('indexpicUrl', NULL, NULL, _t('首页大图'), _t('在这里填入一个图片URL地址, 用于显示首页大图<br>推荐！//api.ikmoe.com/moeu-rand-background.php'));
    $form->addInput($indexpicUrl);

	$archivespicUrl = new Typecho_Widget_Helper_Form_Element_Text('archivespicUrl', NULL, NULL, _t('归档大图'), _t('在这里填入一个图片URL地址, 用于显示归档大图<br>注意！归档页地址必须为xxxx/archives.html'));
    $form->addInput($archivespicUrl);

    $adminpicUrl = new Typecho_Widget_Helper_Form_Element_Text('adminpicUrl', NULL, NULL, _t('博主头像'), _t('在这里填入一个图片URL地址, 用于显示博主头像'));
    $form->addInput($adminpicUrl);

    $authorpicUrl = new Typecho_Widget_Helper_Form_Element_Text('authorpicUrl', NULL, NULL, _t('作者页大图'), _t('在这里填入一个图片URL地址, 用于显示作者页大图'));
    $form->addInput($authorpicUrl);
    
    $searchpicUrl = new Typecho_Widget_Helper_Form_Element_Text('searchpicUrl', NULL, NULL, _t('搜索页大图'), _t('在这里填入一个图片URL地址, 用于显示搜索页大图'));
    $form->addInput($searchpicUrl);

    $wechatpicUrl = new Typecho_Widget_Helper_Form_Element_Text('wechatpicUrl', NULL, NULL, _t('微信支付二维码'), _t('在这里填入一个图片URL地址, 用于显示打赏微信支付二维码'));
    $form->addInput($wechatpicUrl);

    $alipaypicUrl = new Typecho_Widget_Helper_Form_Element_Text('alipaypicUrl', NULL, NULL, _t('支付宝二维码'), _t('在这里填入一个图片URL地址, 用于显示打赏支付宝二维码'));
    $form->addInput($alipaypicUrl);

    //$selfdiscribition = new Typecho_Widget_Helper_Form_Element_Text('selfdiscribition', NULL, NULL, _t('自我介绍'), _t('在这里填入一段话, 用于文章末尾显示介绍，不要过长'));
    //$form->addInput($selfdiscribition);

    $otherOptionsBlock = new Typecho_Widget_Helper_Form_Element_Checkbox('otherOptionsBlock',
        array(
            //'showtags' => _t('文章内容最后显示标签'),
            'enablelikes' => _t('显示文章点赞，必须开启插件'),
            'oninstantclick' => _t('开启instantclick，不能与首页ajax同时启用'),
            'ajaxpost' => _t('开启首页ajax无限加载，不能与instantclick同时启用'),
            'onpinghua' => _t('开启平滑滚动'),
        ),
        array(), _t('其他选项'));
    $form->addInput($otherOptionsBlock->multiMode());

$yetou = new Typecho_Widget_Helper_Form_Element_Textarea('yetou', NULL,NULL, _t('自定义页头代码'), _t('填写需要的代码，比如css样式等，代码将自动插入页头'));
$form->addInput($yetou);

$tongji = new Typecho_Widget_Helper_Form_Element_Textarea('tongji', NULL,NULL, _t('自定义页脚代码'), _t('填写需要的代码，比如统计代码等，代码将自动插入页脚'));
$form->addInput($tongji);

}

function themeInit($archive) {
    Helper::options()->commentsAntiSpam = false;//强制开启后台反垃圾保护
    Helper::options()->commentsCheckReferer = false;//强制开启后台反垃圾保护
    Helper::options()->commentsOrder = 'DESC';//强制最新评论放在最前面
    if ($archive->is('index')) {
        $archive->parameter->pageSize = 6; // 自定义首页文章分页条数
    }
    if ($archive->is('category', 'daily')) {
		$archive->parameter->pageSize = 9; // 分类下的文章列表f分页显示条数daily为分类缩略
	}elseif($archive->is('category', 'code')){
		$archive->parameter->pageSize = 9; // 分类下的文章列表f分页显示条数code为分类缩略
	}
	if( isset($_GET['action']) == 'ajax_avatar_get' && 'GET' == $_SERVER['REQUEST_METHOD'] ) {
$host = 'https://cdn.v2ex.com/gravatar/';
$email = strtolower( $_GET['email']);
            $hash = md5($email);
           $sjtx = 'mm';
 $avatar = $host . $hash . '?d='.$sjtx;
        echo $avatar; 
        die();
    }else { return; }
}

function themeFields($layout) {
    $thumb = new Typecho_Widget_Helper_Form_Element_Text('pic', NULL, NULL, _t('文章缩略图'), _t('输入图片地址'));
    $layout->addItem($thumb);
}

//获取评论的锚点链接
function get_comment_at($coid)
{
    $db   = Typecho_Db::get();
    $prow = $db->fetchRow($db->select('parent')->from('table.comments')
                                 ->where('coid = ? AND status = ?', $coid, 'approved'));
    $parent = $prow['parent'];
    if ($parent != "0") {
        $arow = $db->fetchRow($db->select('author')->from('table.comments')
                                     ->where('coid = ? AND status = ?', $parent, 'approved'));
        $author = $arow['author'];
        $href   = '<span class="comment-reply-author" href="#comment-' . $parent . '"><svg class="reply-icon" viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="200" height="200"><path d="M1.664 902.144s97.92-557.888 596.352-557.888V129.728L1024 515.84l-425.984 360.448V628.8c-270.464 0-455.232 23.872-596.352 273.28"></path></svg>' . $author . '</span>';
        echo $href;
    } else {
        echo '';
    }
}


//评论时间显示多少秒，多少天，多少时
function timesince($older_date,$comment_date = false) {
$chunks = array(
array(86400 , '天'),
array(3600 , '小时'),
array(60 , '分钟'),
array(1 , '秒'),
);
$newer_date = time();
$since = abs($newer_date - $older_date);
if($since < 2592000){
for ($i = 0, $j = count($chunks); $i < $j; $i++){
$seconds = $chunks[$i][0];
$name = $chunks[$i][1];
if (($count = floor($since / $seconds)) != 0) break;
}
$output = $count.$name.'前';
}else{
$output = !$comment_date ? (date('Y-m-j G:i', $older_date)) : (date('Y-m-j', $older_date));
}
return $output;
}

// 评论表情base64加密
function forReplace($m){
return '<img src="/usr/themes/NewCasper/newpaopao/'.base64_encode($m[1]).'.png" class="biaoqing">';
}

function prev_post($archive)
{
    $db = Typecho_Db::get();
    $content = $db->fetchRow($db->select()
            ->from('table.contents')
            ->where('table.contents.created < ?', $archive->created)
            ->where('table.contents.status = ?', 'publish')
            ->where('table.contents.type = ?', $archive->type)
            ->where('table.contents.password IS NULL')
            ->order('table.contents.created', Typecho_Db::SORT_DESC)
            ->limit(1));
    if ($content)
    {
        $content = Typecho_Widget::widget('Widget_Abstract_Contents')->filter($content);
        echo '<article class="post-card post"><!-- <a style="text-decoration: none;" class="post-card-image-link" href="' . $content['permalink'] . '" title="' . $content['title'] . '"><div class="post-card-image" style="position:relative;-ms-flex:1 1 300px;flex:1 1 300px;-ms-flex-direction:column;flex-direction:column;overflow:hidden;color:#fff;background:rgb(4,35,51) 50%;background-size:cover;border-radius:5px;box-shadow:8px 14px 38px rgba(39,44,49,.06),1px 3px 8px rgba(39,44,49,.03);"><ul style="display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;margin:15% auto;padding:0;text-align:center;list-style:none;"><li style="margin:0 auto;padding:0;font-size:1.6rem;line-height:1.25em;font-weight:200;letter-spacing:-.5px;width:50%;"><font style="display:block;padding:10px 0;color:#fff;font-weight:500;vertical-align:top;transition:opacity .3s ease;padding-top:10px;border-radius:10px;font-size:3rem;">上一篇</font></li></ul></div></a> -->    <div class="post-card-content"><a class="post-card-content-link" href="' . $content['permalink'] . '" title="' . $content['title'] . '"><header class="post-card-header"><span class="post-card-tags">' . $content['category'] . '</span><h2 class="post-card-title">' . $content['title'] . '</h2></header><section class="post-card-excerpt">';
    }
    else
    {
        echo '<article class="read-next-card no-prev-article">
                    <header class="read-next-card-header">
                        <small class="read-next-card-header-sitetitle">— yufan —</small>
                        <h3 class="read-next-card-header-title"><a href="https://yufanboke.top/">yufan ‘s blog</a></h3>
                    </header>
                    <div class="read-next-divider"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 14.5s2 3 5 3 5.5-2.463 5.5-5.5S21 6.5 18 6.5c-5 0-7 11-12 11C2.962 17.5.5 15.037.5 12S3 6.5 6 6.5s4.5 3.5 4.5 3.5"></path></svg>
</div>
                    <div class="read-next-card-content">
                        <ul>
                            <li><font style="display: block;padding: 20px 0;border-bottom: 1px solid hsla(0,0%,100%,.3);color: #fff;font-weight: 500;vertical-align: top;transition: opacity .3s ease;padding-top: 10px;">哎呀＞﹏＜</font></li>
                            <li><font style="display: block;padding: 20px 0;border-bottom: 1px solid hsla(0,0%,100%,.3);color: #fff;font-weight: 500;vertical-align: top;transition: opacity .3s ease;padding-top: 10px;">已经没有上一篇了</font></li>
                            <li><font style="display: block;padding: 20px 0;border-bottom: 1px solid hsla(0,0%,100%,.3);color: #fff;font-weight: 500;vertical-align: top;transition: opacity .3s ease;padding-top: 10px;">୧(๑•̀⌄•́๑)૭你已经看到最早的了</font></li>
                        </ul>
                    </div>
                    <footer class="read-next-card-footer">
                        <font>看看新的文章吧 →</font>
                    </footer>
                </article>';
    }
}

function next_post($archive)
{
    $db = Typecho_Db::get();
    $content = $db->fetchRow($db->select()
            ->from('table.contents')
            ->where('table.contents.created > ? AND table.contents.created < ?', $archive->created, Helper::options()->gmtTime)
            ->where('table.contents.status = ?', 'publish')
            ->where('table.contents.type = ?', $archive->type)
            ->where('table.contents.password IS NULL')
            ->order('table.contents.created', Typecho_Db::SORT_ASC)
            ->limit(1));
    if ($content)
    {
        $content = Typecho_Widget::widget('Widget_Abstract_Contents')->filter($content);
        echo '<article class="post-card post"><!-- <a style="text-decoration: none;" class="post-card-image-link" href="' . $content['permalink'] . '"><div class="post-card-image" style="position:relative;-ms-flex:1 1 300px;flex:1 1 300px;-ms-flex-direction:column;flex-direction:column;overflow:hidden;color:#fff;background:rgb(4,35,51) 50%;background-size:cover;border-radius:5px;box-shadow:8px 14px 38px rgba(39,44,49,.06),1px 3px 8px rgba(39,44,49,.03);"><ul style="display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;margin:15% auto;padding:0;text-align:center;list-style:none;"><li style="margin:0 auto;padding:0;font-size:1.6rem;line-height:1.25em;font-weight:200;letter-spacing:-.5px;width:50%;"><font style="display:block;padding:10px 0;color:#fff;font-weight:500;vertical-align:top;transition:opacity .3s ease;padding-top:10px;border-radius:10px;font-size:3rem;">下一篇</font></li></ul></div></a> -->  <div class="post-card-content"><a class="post-card-content-link" href="' . $content['permalink'] . '"><header class="post-card-header"><span class="post-card-tags">' . $content['category'] . '</span><h2 class="post-card-title">' . $content['title'] . '</h2></header><section class="post-card-excerpt">';
    }
    else
    {
        echo '<article class="read-next-card no-next-article">
                    <header class="read-next-card-header">
                        <small class="read-next-card-header-sitetitle">— yufan —</small>
                        <h3 class="read-next-card-header-title"><a href="https://yufanboke.top/">yufan ‘s blog</a></h3>
                    </header>
                    <div class="read-next-divider"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 14.5s2 3 5 3 5.5-2.463 5.5-5.5S21 6.5 18 6.5c-5 0-7 11-12 11C2.962 17.5.5 15.037.5 12S3 6.5 6 6.5s4.5 3.5 4.5 3.5"></path></svg>
</div>
                    <div class="read-next-card-content">
                        <ul>
                            <li><font style="display: block;padding: 20px 0;border-bottom: 1px solid hsla(0,0%,100%,.3);color: #fff;font-weight: 500;vertical-align: top;transition: opacity .3s ease;padding-top: 10px;">哎呀＞﹏＜</font></li>
                            <li><font style="display: block;padding: 20px 0;border-bottom: 1px solid hsla(0,0%,100%,.3);color: #fff;font-weight: 500;vertical-align: top;transition: opacity .3s ease;padding-top: 10px;">已经没有了</font></li>
                            <li><font style="display: block;padding: 20px 0;border-bottom: 1px solid hsla(0,0%,100%,.3);color: #fff;font-weight: 500;vertical-align: top;transition: opacity .3s ease;padding-top: 10px;">୧(๑•̀⌄•́๑)૭马上会有更新的</font></li>
                        </ul>
                    </div>
                    <footer class="read-next-card-footer">
                        <font>← 看看之前的文章吧</font>
                    </footer>
                </article>';
    }
}

function prev_post_content($archive)
{
    $db = Typecho_Db::get();
    $content = $db->fetchRow($db->select()
            ->from('table.contents')
            ->where('table.contents.created < ?', $archive->created)
            ->where('table.contents.status = ?', 'publish')
            ->where('table.contents.type = ?', $archive->type)
            ->where('table.contents.password IS NULL')
            ->order('table.contents.created', Typecho_Db::SORT_DESC)
            ->limit(1));
    if ($content)
    {
        $content = Typecho_Widget::widget('Widget_Abstract_Contents')->filter($content);
        $text = $content['text'];
        $po = preg_replace('#\!\[(.*?)\]\((.*?)\)#','',$text);
        $po1 = preg_replace('#`(.*?)`#','',$po);
        $po2 = preg_replace('#\##','',$po1);
        $po3 = preg_replace('#\[(.*?)\]\((.*?)\)#','',$po2);
        $po4 = preg_replace('#\!\[(.*?)\]\[(.*?)\]#','',$po3);
		$po5 = preg_replace('#\<a(.*?)href="(.*?)"(.*?)>(.*?)</a>#','$4',$po4);
    	echo mb_substr($po5,0,200,'UTF-8');
    }
    else
    {
        echo '';
    }
}

function next_post_content($archive)
{
    $db = Typecho_Db::get();
    $content = $db->fetchRow($db->select()
            ->from('table.contents')
            ->where('table.contents.created > ? AND table.contents.created < ?', $archive->created, Helper::options()->gmtTime)
            ->where('table.contents.status = ?', 'publish')
            ->where('table.contents.type = ?', $archive->type)
            ->where('table.contents.password IS NULL')
            ->order('table.contents.created', Typecho_Db::SORT_ASC)
            ->limit(1));
    if ($content)
    {
        $content = Typecho_Widget::widget('Widget_Abstract_Contents')->filter($content);
        $text = $content['text'];
        $po = preg_replace('#\!\[(.*?)\]\((.*?)\)#','',$text);
        $po1 = preg_replace('#`(.*?)`#','',$po);
        $po2 = preg_replace('#\##','',$po1);
        $po3 = preg_replace('#\[(.*?)\]\((.*?)\)#','',$po2);
        $po4 = preg_replace('#\!\[(.*?)\]\[(.*?)\]#','',$po3);
		$po5 = preg_replace('#\<a(.*?)href="(.*?)"(.*?)>(.*?)</a>#','$4',$po4);
    	echo mb_substr($po5,0,200,'UTF-8');
    }
    else
    {
        echo '';
    }
}


//主题的样式判断
function header_class($archive)
{
	if ($archive->is('index'))
	{
		$class = '';
	}
	if ($archive->is('post'))
	{
		$class = 'post-head';
	}
	if ($archive->is('page'))
	{
		$class = 'post-head';
	}
	if ($archive->is('archive'))
	{
		$class = 'post-head';
	}
	echo $class;
}
function body_class($archive)
{
	if ($archive->is('index'))
	{
		$class = 'home-template';
	}
	if ($archive->is('post'))
	{
		$class = 'post-template';
	}
	if ($archive->is('page'))
	{
		$class = 'post-template';
	}
	if ($archive->is('archive'))
	{
		$class = 'tag-template';
	}
	echo $class;
}
